50042df1b90bbdf7130a1baa4177b531245634ba
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git merge [options] <remote>...
   9git merge [options] <msg> HEAD <remote>
  10--
  11stat                 show a diffstat at the end of the merge
  12n                    don't show a diffstat at the end of the merge
  13summary              (synonym to --stat)
  14log                  add list of one-line log to merge commit message
  15squash               create a single commit instead of doing a merge
  16commit               perform a commit if the merge succeeds (default)
  17ff                   allow fast-forward (default)
  18s,strategy=          merge strategy to use
  19m,message=           message to be used for the merge commit (if any)
  20"
  21
  22SUBDIRECTORY_OK=Yes
  23. git-sh-setup
  24require_work_tree
  25cd_to_toplevel
  26
  27test -z "$(git ls-files -u)" ||
  28        die "Merge is not possible because you have unmerged files."
  29
  30! test -e "$GIT_DIR/MERGE_HEAD" ||
  31        die 'You have not concluded your merge (MERGE_HEAD exists).'
  32
  33LF='
  34'
  35
  36all_strategies='recur recursive octopus resolve stupid ours subtree'
  37all_strategies="$all_strategies recursive-ours recursive-theirs"
  38default_twohead_strategies='recursive'
  39default_octopus_strategies='octopus'
  40no_fast_forward_strategies='subtree ours'
  41no_trivial_strategies='recursive recur subtree ours recursive-ours recursive-theirs'
  42use_strategies=
  43
  44allow_fast_forward=t
  45allow_trivial_merge=t
  46squash= no_commit= log_arg=
  47
  48dropsave() {
  49        rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
  50                 "$GIT_DIR/MERGE_STASH" || exit 1
  51}
  52
  53savestate() {
  54        # Stash away any local modifications.
  55        git stash create >"$GIT_DIR/MERGE_STASH"
  56}
  57
  58restorestate() {
  59        if test -f "$GIT_DIR/MERGE_STASH"
  60        then
  61                git reset --hard $head >/dev/null
  62                git stash apply $(cat "$GIT_DIR/MERGE_STASH")
  63                git update-index --refresh >/dev/null
  64        fi
  65}
  66
  67finish_up_to_date () {
  68        case "$squash" in
  69        t)
  70                echo "$1 (nothing to squash)" ;;
  71        '')
  72                echo "$1" ;;
  73        esac
  74        dropsave
  75}
  76
  77squash_message () {
  78        echo Squashed commit of the following:
  79        echo
  80        git log --no-merges --pretty=medium ^"$head" $remoteheads
  81}
  82
  83finish () {
  84        if test '' = "$2"
  85        then
  86                rlogm="$GIT_REFLOG_ACTION"
  87        else
  88                echo "$2"
  89                rlogm="$GIT_REFLOG_ACTION: $2"
  90        fi
  91        case "$squash" in
  92        t)
  93                echo "Squash commit -- not updating HEAD"
  94                squash_message >"$GIT_DIR/SQUASH_MSG"
  95                ;;
  96        '')
  97                case "$merge_msg" in
  98                '')
  99                        echo "No merge message -- not updating HEAD"
 100                        ;;
 101                *)
 102                        git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
 103                        git gc --auto
 104                        ;;
 105                esac
 106                ;;
 107        esac
 108        case "$1" in
 109        '')
 110                ;;
 111        ?*)
 112                if test "$show_diffstat" = t
 113                then
 114                        # We want color (if set), but no pager
 115                        GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
 116                fi
 117                ;;
 118        esac
 119
 120        # Run a post-merge hook
 121        if test -x "$GIT_DIR"/hooks/post-merge
 122        then
 123            case "$squash" in
 124            t)
 125                "$GIT_DIR"/hooks/post-merge 1
 126                ;;
 127            '')
 128                "$GIT_DIR"/hooks/post-merge 0
 129                ;;
 130            esac
 131        fi
 132}
 133
 134merge_name () {
 135        remote="$1"
 136        rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
 137        bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
 138        if test "$rh" = "$bh"
 139        then
 140                echo "$rh               branch '$remote' of ."
 141        elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
 142                git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
 143        then
 144                echo "$rh               branch '$truname' (early part) of ."
 145        elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
 146        then
 147                sed -e 's/      not-for-merge   /               /' -e 1q \
 148                        "$GIT_DIR/FETCH_HEAD"
 149        else
 150                echo "$rh               commit '$remote'"
 151        fi
 152}
 153
 154parse_config () {
 155        while test $# != 0; do
 156                case "$1" in
 157                -n|--no-stat|--no-summary)
 158                        show_diffstat=false ;;
 159                --stat|--summary)
 160                        show_diffstat=t ;;
 161                --log|--no-log)
 162                        log_arg=$1 ;;
 163                --squash)
 164                        test "$allow_fast_forward" = t ||
 165                                die "You cannot combine --squash with --no-ff."
 166                        squash=t no_commit=t ;;
 167                --no-squash)
 168                        squash= no_commit= ;;
 169                --commit)
 170                        no_commit= ;;
 171                --no-commit)
 172                        no_commit=t ;;
 173                --ff)
 174                        allow_fast_forward=t ;;
 175                --no-ff)
 176                        test "$squash" != t ||
 177                                die "You cannot combine --squash with --no-ff."
 178                        allow_fast_forward=f ;;
 179                -s|--strategy)
 180                        shift
 181                        case " $all_strategies " in
 182                        *" $1 "*)
 183                                use_strategies="$use_strategies$1 " ;;
 184                        *)
 185                                die "available strategies are: $all_strategies" ;;
 186                        esac
 187                        ;;
 188                -m|--message)
 189                        shift
 190                        merge_msg="$1"
 191                        have_message=t
 192                        ;;
 193                --)
 194                        shift
 195                        break ;;
 196                *)      usage ;;
 197                esac
 198                shift
 199        done
 200        args_left=$#
 201}
 202
 203test $# != 0 || usage
 204
 205have_message=
 206
 207if branch=$(git-symbolic-ref -q HEAD)
 208then
 209        mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
 210        if test -n "$mergeopts"
 211        then
 212                parse_config $mergeopts --
 213        fi
 214fi
 215
 216parse_config "$@"
 217while test $args_left -lt $#; do shift; done
 218
 219if test -z "$show_diffstat"; then
 220    test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
 221    test "$(git config --bool merge.stat)" = false && show_diffstat=false
 222    test -z "$show_diffstat" && show_diffstat=t
 223fi
 224
 225# This could be traditional "merge <msg> HEAD <commit>..."  and the
 226# way we can tell it is to see if the second token is HEAD, but some
 227# people might have misused the interface and used a committish that
 228# is the same as HEAD there instead.  Traditional format never would
 229# have "-m" so it is an additional safety measure to check for it.
 230
 231if test -z "$have_message" &&
 232        second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
 233        head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
 234        test "$second_token" = "$head_commit"
 235then
 236        merge_msg="$1"
 237        shift
 238        head_arg="$1"
 239        shift
 240elif ! git rev-parse --verify HEAD >/dev/null 2>&1
 241then
 242        # If the merged head is a valid one there is no reason to
 243        # forbid "git merge" into a branch yet to be born.  We do
 244        # the same for "git pull".
 245        if test 1 -ne $#
 246        then
 247                echo >&2 "Can merge only exactly one commit into empty head"
 248                exit 1
 249        fi
 250
 251        test "$squash" != t ||
 252                die "Squash commit into empty head not supported yet"
 253        test "$allow_fast_forward" = t ||
 254                die "Non-fast-forward into an empty head does not make sense"
 255        rh=$(git rev-parse --verify "$1^0") ||
 256                die "$1 - not something we can merge"
 257
 258        git update-ref -m "initial pull" HEAD "$rh" "" &&
 259        git read-tree --reset -u HEAD
 260        exit
 261
 262else
 263        # We are invoked directly as the first-class UI.
 264        head_arg=HEAD
 265
 266        # All the rest are the commits being merged; prepare
 267        # the standard merge summary message to be appended to
 268        # the given message.  If remote is invalid we will die
 269        # later in the common codepath so we discard the error
 270        # in this loop.
 271        merge_name=$(for remote
 272                do
 273                        merge_name "$remote"
 274                done | git fmt-merge-msg $log_arg
 275        )
 276        merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
 277fi
 278head=$(git rev-parse --verify "$head_arg"^0) || usage
 279
 280# All the rest are remote heads
 281test "$#" = 0 && usage ;# we need at least one remote head.
 282set_reflog_action "merge $*"
 283
 284remoteheads=
 285for remote
 286do
 287        remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
 288            die "$remote - not something we can merge"
 289        remoteheads="${remoteheads}$remotehead "
 290        eval GITHEAD_$remotehead='"$remote"'
 291        export GITHEAD_$remotehead
 292done
 293set x $remoteheads ; shift
 294
 295case "$use_strategies" in
 296'')
 297        case "$#" in
 298        1)
 299                var="`git config --get pull.twohead`"
 300                if test -n "$var"
 301                then
 302                        use_strategies="$var"
 303                else
 304                        use_strategies="$default_twohead_strategies"
 305                fi ;;
 306        *)
 307                var="`git config --get pull.octopus`"
 308                if test -n "$var"
 309                then
 310                        use_strategies="$var"
 311                else
 312                        use_strategies="$default_octopus_strategies"
 313                fi ;;
 314        esac
 315        ;;
 316esac
 317
 318for s in $use_strategies
 319do
 320        for ss in $no_fast_forward_strategies
 321        do
 322                case " $s " in
 323                *" $ss "*)
 324                        allow_fast_forward=f
 325                        break
 326                        ;;
 327                esac
 328        done
 329        for ss in $no_trivial_strategies
 330        do
 331                case " $s " in
 332                *" $ss "*)
 333                        allow_trivial_merge=f
 334                        break
 335                        ;;
 336                esac
 337        done
 338done
 339
 340case "$#" in
 3411)
 342        common=$(git merge-base --all $head "$@")
 343        ;;
 344*)
 345        common=$(git show-branch --merge-base $head "$@")
 346        ;;
 347esac
 348echo "$head" >"$GIT_DIR/ORIG_HEAD"
 349
 350case "$allow_fast_forward,$#,$common,$no_commit" in
 351?,*,'',*)
 352        # No common ancestors found. We need a real merge.
 353        ;;
 354?,1,"$1",*)
 355        # If head can reach all the merge then we are up to date.
 356        # but first the most common case of merging one remote.
 357        finish_up_to_date "Already up-to-date."
 358        exit 0
 359        ;;
 360t,1,"$head",*)
 361        # Again the most common case of merging one remote.
 362        echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
 363        git update-index --refresh 2>/dev/null
 364        msg="Fast-forward"
 365        if test -n "$have_message"
 366        then
 367                msg="$msg (no commit created; -m option ignored)"
 368        fi
 369        new_head=$(git rev-parse --verify "$1^0") &&
 370        git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
 371        finish "$new_head" "$msg" || exit
 372        dropsave
 373        exit 0
 374        ;;
 375?,1,?*"$LF"?*,*)
 376        # We are not doing octopus and not fast-forward.  Need a
 377        # real merge.
 378        ;;
 379?,1,*,)
 380        # We are not doing octopus, not fast-forward, and have only
 381        # one common.
 382        git update-index --refresh 2>/dev/null
 383        case "$allow_trivial_merge" in
 384        t)
 385                # See if it is really trivial.
 386                git var GIT_COMMITTER_IDENT >/dev/null || exit
 387                echo "Trying really trivial in-index merge..."
 388                if git read-tree --trivial -m -u -v $common $head "$1" &&
 389                   result_tree=$(git write-tree)
 390                then
 391                        echo "Wonderful."
 392                        result_commit=$(
 393                                printf '%s\n' "$merge_msg" |
 394                                git commit-tree $result_tree -p HEAD -p "$1"
 395                        ) || exit
 396                        finish "$result_commit" "In-index merge"
 397                        dropsave
 398                        exit 0
 399                fi
 400                echo "Nope."
 401        esac
 402        ;;
 403*)
 404        # An octopus.  If we can reach all the remote we are up to date.
 405        up_to_date=t
 406        for remote
 407        do
 408                common_one=$(git merge-base --all $head $remote)
 409                if test "$common_one" != "$remote"
 410                then
 411                        up_to_date=f
 412                        break
 413                fi
 414        done
 415        if test "$up_to_date" = t
 416        then
 417                finish_up_to_date "Already up-to-date. Yeeah!"
 418                exit 0
 419        fi
 420        ;;
 421esac
 422
 423# We are going to make a new commit.
 424git var GIT_COMMITTER_IDENT >/dev/null || exit
 425
 426# At this point, we need a real merge.  No matter what strategy
 427# we use, it would operate on the index, possibly affecting the
 428# working tree, and when resolved cleanly, have the desired tree
 429# in the index -- this means that the index must be in sync with
 430# the $head commit.  The strategies are responsible to ensure this.
 431
 432case "$use_strategies" in
 433?*' '?*)
 434    # Stash away the local changes so that we can try more than one.
 435    savestate
 436    single_strategy=no
 437    ;;
 438*)
 439    rm -f "$GIT_DIR/MERGE_STASH"
 440    single_strategy=yes
 441    ;;
 442esac
 443
 444result_tree= best_cnt=-1 best_strategy= wt_strategy=
 445merge_was_ok=
 446for strategy in $use_strategies
 447do
 448    test "$wt_strategy" = '' || {
 449        echo "Rewinding the tree to pristine..."
 450        restorestate
 451    }
 452    case "$single_strategy" in
 453    no)
 454        echo "Trying merge strategy $strategy..."
 455        ;;
 456    esac
 457
 458    # Remember which strategy left the state in the working tree
 459    wt_strategy=$strategy
 460
 461    git-merge-$strategy $common -- "$head_arg" "$@"
 462    exit=$?
 463    if test "$no_commit" = t && test "$exit" = 0
 464    then
 465        merge_was_ok=t
 466        exit=1 ;# pretend it left conflicts.
 467    fi
 468
 469    test "$exit" = 0 || {
 470
 471        # The backend exits with 1 when conflicts are left to be resolved,
 472        # with 2 when it does not handle the given merge at all.
 473
 474        if test "$exit" -eq 1
 475        then
 476            cnt=`{
 477                git diff-files --name-only
 478                git ls-files --unmerged
 479            } | wc -l`
 480            if test $best_cnt -le 0 -o $cnt -le $best_cnt
 481            then
 482                best_strategy=$strategy
 483                best_cnt=$cnt
 484            fi
 485        fi
 486        continue
 487    }
 488
 489    # Automerge succeeded.
 490    result_tree=$(git write-tree) && break
 491done
 492
 493# If we have a resulting tree, that means the strategy module
 494# auto resolved the merge cleanly.
 495if test '' != "$result_tree"
 496then
 497    if test "$allow_fast_forward" = "t"
 498    then
 499        parents=$(git show-branch --independent "$head" "$@")
 500    else
 501        parents=$(git rev-parse "$head" "$@")
 502    fi
 503    parents=$(echo "$parents" | sed -e 's/^/-p /')
 504    result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
 505    finish "$result_commit" "Merge made by $wt_strategy."
 506    dropsave
 507    exit 0
 508fi
 509
 510# Pick the result from the best strategy and have the user fix it up.
 511case "$best_strategy" in
 512'')
 513        restorestate
 514        case "$use_strategies" in
 515        ?*' '?*)
 516                echo >&2 "No merge strategy handled the merge."
 517                ;;
 518        *)
 519                echo >&2 "Merge with strategy $use_strategies failed."
 520                ;;
 521        esac
 522        exit 2
 523        ;;
 524"$wt_strategy")
 525        # We already have its result in the working tree.
 526        ;;
 527*)
 528        echo "Rewinding the tree to pristine..."
 529        restorestate
 530        echo "Using the $best_strategy to prepare resolving by hand."
 531        git-merge-$best_strategy $common -- "$head_arg" "$@"
 532        ;;
 533esac
 534
 535if test "$squash" = t
 536then
 537        finish
 538else
 539        for remote
 540        do
 541                echo $remote
 542        done >"$GIT_DIR/MERGE_HEAD"
 543        printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
 544fi
 545
 546if test "$merge_was_ok" = t
 547then
 548        echo >&2 \
 549        "Automatic merge went well; stopped before committing as requested"
 550        exit 0
 551else
 552        {
 553            echo '
 554Conflicts:
 555'
 556                git ls-files --unmerged |
 557                sed -e 's/^[^   ]*      /       /' |
 558                uniq
 559        } >>"$GIT_DIR/MERGE_MSG"
 560        git rerere
 561        die "Automatic merge failed; fix conflicts and then commit the result."
 562fi